import os
import gc
import pygtk
pygtk.require('2.0')
import gtk
import gtkmozembed
import gobject
import datetime
from config import *

"""

	Video Booth Kiosk Application v2
	Author: Robin Rawson-Tetley

"""


class MainWindow(gtk.Window):

	def destroy(self, widget, data=None):
		gtk.main_quit()

	def delete_event(self, widget, event, data=None):
		return False

	def gointernet(self, widget, data=None):
		self.layout.remove(self.ctlaunch)
		try :
			del self.moz
		except:
			pass
		self.moz = gtkmozembed.MozEmbed()
		self.ctbrowser.attach(self.moz, 0, 1, 0, 1, gtk.EXPAND | gtk.FILL, gtk.EXPAND | gtk.FILL)
		self.layout.add(self.ctbrowser)
		self.layout.show_all()
		self.moz.load_url("http://www.google.com")
	
	def loadfromfile(self, filename):
		"""
		Loads the contents of a file and returns it as a string
		"""
		f = open(filename)
		out = ""
		while True:
			s = f.readline()
			if s == "": break
			out = out + s
		del f
		return out

	def loadcombo(self, combo, filename):
		"""
		Loads the contents of a file into a combo
		"""
		f = open(filename)
		l = f.readlines()
		f.close()
		del f
		for i in l:
			combo.append_text(i.strip())
		del i
		del l

	def goorgwww(self, widget, data=None):
		self.layout.remove(self.ctlaunch)
		try:
			del self.moz
		except:
			pass
		self.moz = gtkmozembed.MozEmbed()
		self.ctbrowser.attach(self.moz, 0, 1, 0, 1, gtk.EXPAND | gtk.FILL, gtk.EXPAND | gtk.FILL)
		self.layout.add(self.ctbrowser)
		self.layout.show_all()
		self.moz.load_url(ORG_URL)

	def stopbrowser(self, widget, data=None):
		# Close browser, return to launcher
		del self.moz
		self.layout.remove(self.ctbrowser)
		self.layout.add(self.ctlaunch)
		self.layout.show_all()

	def browsergoback(self, widget, data=None):
		# Send browser back
		self.moz.go_back()

	def browsergoforward(self, widget, data=None):
		# Send browser back
		self.moz.go_forward()

	def creatediary(self, widget, data=None):
		# Clear request fields
		self.clearfields()
		# Go to the info request form
		self.layout.remove(self.ctlaunch)
		self.layout.add(self.ctdiaryinfo)
		self.layout.show_all()
		# Set name with focus
		self.enname.grab_focus()

	def recorddiary(self, widget, data=None):
		# Figure out whether it's audio AND video
		self.isaudioonly = self.btnaudioonly.get_active()
		# Get a readable date time and a timestamp for the filename
		d = datetime.datetime.today()
		filename = d.strftime("%Y%m%d%H%M%S")
		readabledate = d.strftime("%d/%m/%Y %H:%M:%S")
		# Substitute personal data overlay
		name = self.enname.get_text()
		age = self.enage.get_text()
		if name == "": name = NOT_GIVEN
		if age == "": age = NOT_GIVEN
		personaldata = readabledate
		# Name
		personaldata = personaldata + ": " + name + ", "
		# Gender/Age
		personaldata = personaldata + self.cbsex.get_active_text() + " aged "
		personaldata = personaldata + age + ", "
		# Ethnic origin
		personaldata = personaldata + self.cbethnic.get_active_text()
		# Service
		personaldata = personaldata + ": " + self.cbservice.get_active_text()
		# Write the substitles file for the movie showing personal data
		f = open(MOVIE_HOME + "/" + filename + ".srt", "w")
		f.write("1\n")
		f.write("00:00:00,000 --> " + MAX_MOVIETIME + "\n")
		f.write(personaldata)
		f.close()
		# Start the record app
		if self.isaudioonly:
			audioonly = "true"
		else:
			audioonly = "false"
		cmd = "python record.py %s %s/%s.%s" % ( audioonly, MOVIE_HOME, filename, MOVIE_EXT )
		# print "Record: " + cmd
		os.system(cmd)
		# Clean up
		del d
		del f
		del personaldata
		del filename
		del readabledate
		del name
		del age
		# Go back to the launch page
		self.backdiary()

	def clearfields(self):
		self.cbethnic.set_active(0)
		self.cbsex.set_active(0)
		self.cbservice.set_active(0)
		self.enage.set_text("")
		self.enname.set_text("")
		self.btnaudioonly.set_active(False)
		self.btnvideoaudio.set_active(True)

	def backdiary(self, widget=None, data=None):
		# Back to launch
		self.layout.remove(self.ctdiaryinfo)
		self.layout.add(self.ctlaunch)
		self.layout.show_all()
		self.btndiary.grab_focus()		

	def backthanks(self, widget=None, data=None):
		# Back to launch
		self.layout.remove(self.ctthanks)
		self.layout.add(self.ctlaunch)
		self.layout.show_all()
		return False


	def imagebutton(self, img_filename, label_text):
		""" Creates an icon/label for use on buttons """
		box1 = gtk.HBox(False, 0)
	        box1.set_border_width(2)
		image = gtk.Image()
		image.set_from_file(img_filename)
		label = gtk.Label(label_text)
		box1.pack_start(image, False, False, 3)
		box1.pack_start(label, False, False, 3)
		image.show()
		label.show()
		return box1

	def __init__(self):
		
		# Default values =======================
		self.isaudioonly = False

		# Window stuff =========================
		gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
		self.connect("delete_event", self.delete_event)
		self.connect("destroy", self.destroy)
		self.set_title("Video Booth")
		# Disable decoration
		self.set_decorated(False)
		self.layout = gtk.VBox(1)
		

		# Launchpad screen ====================
		self.ctlaunch = gtk.Fixed()
		self.lbuttons = gtk.HButtonBox()
		self.lbuttons.set_layout(gtk.BUTTONBOX_SPREAD)
		buttonx = 400
		if ENABLE_ORGWWW: buttonx = buttonx - 150
		if ENABLE_WWW: buttonx = buttonx - 150
		self.ctlaunch.put(self.lbuttons, buttonx, 500)
		# Instructions
		self.lbllaunch = gtk.Label(self.loadfromfile("instructions.txt"))
		self.ctlaunch.put(self.lbllaunch, 250, 600)
		# Disclaimer
		self.lbldisclaimer = gtk.Label(self.loadfromfile("disclaimer.txt"))
		self.ctlaunch.put(self.lbldisclaimer, 100, 100)
		# Diary button
		self.btndiary = gtk.Button()
		self.btndiary.add(self.imagebutton("icons/videoaudio.png", "Record Audio/Video Diary"))
		self.btndiary.connect("clicked", self.creatediary, None)
		self.lbuttons.add(self.btndiary)
		# Org WWW
		self.btntp = gtk.Button()
		self.btntp.add(self.imagebutton("icons/org.png", ORG_WEBSITE))
		self.btntp.connect("clicked", self.goorgwww, None)
		if ENABLE_ORGWWW: self.lbuttons.add(self.btntp)
		# Internet
		self.btninternet = gtk.Button()
		self.btninternet.add(self.imagebutton("icons/internet.png", "Access the WWW"))
		self.btninternet.connect("clicked", self.gointernet, None)
		if ENABLE_WWW: self.lbuttons.add(self.btninternet)


		# Request Info screen ================
		self.ctdiaryinfo = gtk.VBox(3)
		self.ctdiaryinfo.add(gtk.Label(self.loadfromfile("information.txt")))
		# Table layout of info - 5 rows, 2 cols
		self.tblinfo = gtk.Table(1, 2, False)
		# User name
		self.tblinfo.attach(gtk.Label("Your Name:"), 0, 1, 0, 1, gtk.SHRINK, gtk.SHRINK, 50)
		self.enname = gtk.Entry()
		self.enname.set_max_length(25)
		self.tblinfo.attach(self.enname, 1, 2, 0, 1, gtk.EXPAND | gtk.SHRINK | gtk.FILL, gtk.SHRINK, 50)
		# Age
		self.tblinfo.attach(gtk.Label("Age:"), 0, 1, 1, 2, gtk.SHRINK, gtk.SHRINK, 50)
		self.enage = gtk.Entry()
		self.enage.set_max_length(3)
		self.tblinfo.attach(self.enage, 1, 2, 1, 2, gtk.EXPAND | gtk.SHRINK | gtk.FILL, gtk.SHRINK, 50)
		# Sex
		self.tblinfo.attach(gtk.Label("Sex:"), 0, 1, 2, 3, gtk.SHRINK, gtk.SHRINK, 50)
		self.cbsex = gtk.combo_box_new_text()
		self.cbsex.append_text(NOT_GIVEN)
		self.cbsex.append_text("Male")
		self.cbsex.append_text("Female")
		self.cbsex.set_active(0)
		self.tblinfo.attach(self.cbsex, 1, 2, 2, 3, gtk.EXPAND | gtk.SHRINK | gtk.FILL, gtk.SHRINK, 50)
		# Service Type
		self.tblinfo.attach(gtk.Label("Service User:"), 0, 1, 3, 4, gtk.SHRINK, gtk.SHRINK, 50)
		self.cbservice = gtk.combo_box_new_text()
		self.cbservice.append_text(NOT_GIVEN)
		self.loadcombo(self.cbservice, "serviceuser.txt")
		self.cbservice.set_active(0)
		self.tblinfo.attach(self.cbservice, 1, 2, 3, 4, gtk.EXPAND | gtk.SHRINK | gtk.FILL, gtk.SHRINK, 50)

		# Ethnic Origin
		self.tblinfo.attach(gtk.Label("Ethnic Origin:"), 0, 1, 4, 5, gtk.SHRINK, gtk.SHRINK, 50)
		self.cbethnic = gtk.combo_box_new_text()
		self.cbethnic.append_text(NOT_GIVEN)
		self.loadcombo(self.cbethnic, "ethnic.txt")
		self.cbethnic.set_active(0)
		self.tblinfo.attach(self.cbethnic, 1, 2, 4, 5, gtk.EXPAND | gtk.SHRINK | gtk.FILL, gtk.SHRINK, 50)

		# Recording type
		self.tblinfo.attach(gtk.Label("Recording Type:"), 0, 1, 5, 6, gtk.SHRINK, gtk.SHRINK, 50)
		self.rectypebb = gtk.HButtonBox()
		self.rectypebb.set_layout(gtk.BUTTONBOX_START)
		self.btnvideoaudio = gtk.RadioButton(None)
		self.btnvideoaudio.add(self.imagebutton("icons/videoaudio.png", "Video/Audio"))
		self.btnvideoaudio.set_active(True)
		#self.btnvideoaudio.connect("clicked", self.videopressed, None)
		self.rectypebb.add(self.btnvideoaudio)
		self.btnaudioonly = gtk.RadioButton(self.btnvideoaudio)
		self.btnaudioonly.add(self.imagebutton("icons/audioonly.png", "Audio Only"))
		self.btnaudioonly.set_active(False)
		#self.btnaudioonly.connect("clicked", self.audiopressed, None)
		self.rectypebb.add(self.btnaudioonly)
		self.tblinfo.attach(self.rectypebb, 1, 2, 5, 6, gtk.EXPAND | gtk.SHRINK | gtk.FILL, gtk.SHRINK, 50)
		self.ctdiaryinfo.add(self.tblinfo)
		# HButton box with option buttons in the lower half
		self.diaryinfobut = gtk.HButtonBox()
		self.diaryinfobut.set_layout(gtk.BUTTONBOX_SPREAD)
		self.diaryinfobut.set_spacing(20)
		# Record
		self.btnrecorddiary = gtk.Button()
		self.btnrecorddiary.add(self.imagebutton("icons/record.png", "Record"))
		self.btnrecorddiary.connect("clicked", self.recorddiary, None)
		self.diaryinfobut.add(self.btnrecorddiary)
		# Cancel
		self.btnbackdiary = gtk.Button()
		self.btnbackdiary.add(self.imagebutton("icons/back.png", "Back"))
		self.btnbackdiary.connect("clicked", self.backdiary, None)
		self.diaryinfobut.add(self.btnbackdiary)
		self.ctdiaryinfo.add(self.diaryinfobut)








		# Browser screen ====================
		self.ctbrowser = gtk.Table(2, 1, False)
		self.ctbb = gtk.HButtonBox()
		self.ctbb.set_layout(gtk.BUTTONBOX_END)
		self.ctbrowser.attach(self.ctbb, 0, 1, 1, 2, gtk.EXPAND | gtk.FILL, gtk.SHRINK)
		self.moz = gtk.Label()
		#self.moz = gtkmozembed.MozEmbed()
		#self.ctbrowser.attach(self.moz, 0, 1, 0, 1, gtk.EXPAND | gtk.FILL, gtk.EXPAND | gtk.FILL)
		self.btnbback = gtk.Button()
		self.btnbback.add(self.imagebutton("icons/back.png", "Back"))
		self.btnbback.connect("clicked", self.browsergoback)
		self.ctbb.add(self.btnbback)
		self.btnbforward = gtk.Button()
		self.btnbforward.add(self.imagebutton("icons/forward.png", "Forward"))
		self.btnbforward.connect("clicked", self.browsergoforward)
		self.ctbb.add(self.btnbforward)
		#self.enaddress = gtk.Entry()
		#self.ctbb.add(self.enaddress)
		self.btnblaunch = gtk.Button()
		self.btnblaunch.add(self.imagebutton("icons/exit.png", "Exit"))
		self.btnblaunch.connect("clicked", self.stopbrowser)
		self.ctbb.add(self.btnblaunch)




		# Launchpad is default
		self.layout.add(self.ctlaunch)
		# Display our window
		self.layout.show_all()
		self.add(self.layout)
		self.move(0, 0)
		self.resize(SCREEN_WIDTH, SCREEN_HEIGHT)
		self.realize()
		self.show()
		# Load background pixmap and cache it
		self.pixbuf = gtk.gdk.pixbuf_new_from_file("images/bg_%sx%s.jpg" % (SCREEN_WIDTH, SCREEN_HEIGHT))
		self.pixmap, self.mask = self.pixbuf.render_pixmap_and_mask()
		self.set_app_paintable(True)
		self.window.set_back_pixmap(self.pixmap, False)
		del self.pixbuf
		del self.mask
		del self.pixmap

	def main(self):
		gtk.threads_init()
		gtk.main()









if __name__ == "__main__":
	m = MainWindow()
	m.main()
